<form {{will-destroy this.removeEmbedAutoEventListener}} {{on "submit" this.validateAnswer}}>
  {{#if this.showProposal}}
    <div class="rounded-panel__row challenge-response {{if @answer 'challenge-response--locked'}}">
      <h2 class="sr-only">{{t "pages.challenge.parts.answer-input"}}</h2>
      <div class="challenge-proposals qroc-proposal">
        {{#each this._blocks as |block|}}
          {{#if block.text}}
            <label for="qroc_input">
              <MarkdownToHtmlUnsafe class="qroc_input-label" @extensions="remove-paragraph-tags" @markdown={{block.text}} />
            </label>
          {{/if}}

          {{#if block.input}}
            {{#if (eq block.type "select")}}
              <div class="challenge-response__proposal challenge-response__proposal--selector">
                <PixSelect
                  data-uid="qroc-proposal-uid"
                  data-test="challenge-response-proposal-selector"
                  @isDisabled={{this.isAnswerFieldDisabled}}
                  @label={{block.ariaLabel}}
                  @screenReaderOnly={{true}}
                  @placeholder={{block.placeholder}}
                  @value={{this.qcrocProposalAnswerValue}}
                  @hideDefaultOption={{true}}
                  @options={{block.options}}
                  @onChange={{this.onChangeSelect}}
                  @size="big"
                />
              </div>
            {{else if (eq @challenge.format "paragraphe")}}
              <textarea
                class="challenge-response__proposal challenge-response__proposal--paragraph"
                data-test="challenge-response-proposal-selector"
                rows="5"
                id="qroc_input"
                {{on "keyup" this.answerChanged}}
                name={{block.randomName}}
                placeholder={{block.placeholder}}
                autocomplete="nope"
                value={{this.userAnswer}}
                data-uid="qroc-proposal-uid"
                disabled={{this.isAnswerFieldDisabled}}
              >
              </textarea>
            {{else if (eq @challenge.format "phrase")}}
              <input
                class="challenge-response__proposal challenge-response__proposal--sentence"
                data-test="challenge-response-proposal-selector"
                type="text"
                id="qroc_input"
                {{on "keyup" this.answerChanged}}
                name={{block.randomName}}
                placeholder={{block.placeholder}}
                autocomplete="nope"
                value={{this.userAnswer}}
                data-uid="qroc-proposal-uid"
                disabled={{this.isAnswerFieldDisabled}}
              />
            {{else if (eq @challenge.format "nombre")}}
              <PixInput
                @id="qroc_input"
                name={{block.randomName}}
                type="number"
                min="0"
                data-test="challenge-response-proposal-selector"
                placeholder={{block.placeholder}}
                @value={{this.userAnswer}}
                aria-label={{block.ariaLabel}}
                data-uid="qroc-proposal-uid"
                disabled={{this.isAnswerFieldDisabled}}
                {{on "keyup" this.answerChanged}}
              />

            {{else}}
              <input
                class="challenge-response__proposal"
                data-test="challenge-response-proposal-selector"
                size="{{get-qroc-input-size @challenge.format}}"
                type="text"
                id="qroc_input"
                {{on "keyup" this.answerChanged}}
                name={{block.randomName}}
                placeholder={{block.placeholder}}
                autocomplete="nope"
                value={{this.userAnswer}}
                data-uid="qroc-proposal-uid"
                disabled={{this.isAnswerFieldDisabled}}
              />
            {{/if}}
          {{/if}}

          {{#if block.breakline}}
            <br />
          {{/if}}

        {{/each}}
      </div>

      {{#if @answer}}
        <div class="challenge-response__locked-overlay">
          <FaIcon @icon="lock" class="challenge-response-locked__icon" />
        </div>
      {{/if}}

      {{#if this.displayTimer}}
        <div class="timeout-gauge-wrapper">
          <TimeoutGauge
            @allottedTime={{@challenge.timer}}
            @hasTimeoutChallenge={{@assessment.hasTimeoutChallenge}}
            @setChallengeAsTimedOut={{this.setChallengeAsTimedOut}}
          />
        </div>
      {{/if}}
    </div>
  {{/if}}

  {{#if this.errorMessage}}
    <PixMessage class="challenge-response__alert" @type="error" @withIcon={{true}}>
      {{this.errorMessage}}
    </PixMessage>
  {{/if}}

  {{#if @assessment}}
    <ChallengeActions
      @challenge={{@challenge}}
      @answer={{@answer}}
      @isCertification={{@assessment.isCertification}}
      @resumeAssessment={{this.resumeAssessment}}
      @isDisabled={{this.isAnswerFieldDisabled}}
      @validateAnswer={{this.validateAnswer}}
      @skipChallenge={{this.skipChallenge}}
      @hasChallengeTimedOut={{this.hasChallengeTimedOut}}
      @hasFocusedOutOfWindow={{@hasFocusedOutOfWindow}}
    />
  {{/if}}
</form>